unit GlobalVar;
{Pascal shell - program uatwiajcy stworzenie rodowiska programowania dla
 dowolnego kompilatora.
 Program umozliwia wywoanie dowolnego edytora tekstu, wywouje kompilator,
 wywietla opisy bdw kompilacji i uruchamia skompilowany program. Istnieje
 take mozliwo wywoywania plikw pomocy.
 Kod rdowy programu dostpny jest pod adresem:  http://akropolis.pol.lublin.pl/lmn/
 i moze byc rozpowszechniany na zasadach Open Source.
 Autor (Jerzy Podgrski) prosi o informacje dotyczce wykorzystania tego kodu do
 wasnych celw na adres:
 jpkmb@akropolis.pol.lublin.pl
}


interface

uses SysUtils;

type TOpis = record
               Lang : string[10];
               Ext  : string[4];
               Opis : string[80];
               Env  : string;
               OK   : boolean;
             end;

const

  NullFileName='';
  Edytor_Exe      : string='';
  Kompilator_Exe  : string='';
  ProblemFileName : string='Start.pas';
  ProblemDir      : string='';
  RTL_file        : string='';
  Reference_file  : string='';
  User_manual_file: string='';
  PDF_Reader      : string='';
  ShellPath       : string='';
  ShellCfgFile    : string='PASshell.par';
  TimeStart       : TDateTime=0;


procedure Init_Var;
procedure Write_New_file;
procedure ZapiszNazwy;


implementation

procedure ExtractShellPath;
begin
  ShellPath:=ExtractFileDir(ParamStr(0))+'\';
end;

procedure CzytajNazwy;
var f:TextFile;
    err:integer;
begin
  ExtractShellPath;
  AssignFile(f,ShellPath+ShellCfgFile);
  {$I-}
  Reset(f);
  {$I+}
  err:=IOresult;
  if err=0 then
  begin
    readln(f,Edytor_Exe);
    readln(f,Kompilator_Exe);
    readln(f,RTL_file);
    readln(f,Reference_file);
    readln(f,User_manual_file);
    readln(f,PDF_Reader);
    CloseFile(f);
  end;
end;

procedure Init_Var;
var err:integer;
begin
// init

  ProblemDir:=GetEnvironmentVariable('USERPROFILE')+'\Programy_PAS';
  {$I-}
  MkDir(ProblemDir);
  {$I+}
  err:=IOresult;
  ProblemDir:=ProblemDir+'\';
  ExtractShellPath;
  CzytajNazwy;
end;

procedure ZapiszNazwy;
var f:TextFile;
    err:integer;
begin
  AssignFile(f,ShellPath+ShellCfgFile);
  {$I-}
  Rewrite(f);
  {$I+}
  err:=IOresult;
  if err=0 then
  begin
    writeln(f,Edytor_Exe);
    writeln(f,Kompilator_Exe);
    writeln(f,RTL_file);
    writeln(f,Reference_file);
    writeln(f,User_manual_file);
    writeln(f,PDF_Reader);
    CloseFile(f);
  end;
end;

procedure Write_New_file;
var f   : TextFile;
    Err : integer;

begin
  if FileExists(ProblemFileName) then exit;
  if ProblemFileName='' then exit;

  assign(f,ProblemFileName);
  {$I-}
  rewrite(f);
  {$I+}
  Err:=IOresult;
  if Err>0 then exit;

  writeln(f,'program '+ChangeFileExt(ProblemFileName,'')+';');
  writeln(f,'var  : ;');
  writeln(f,'begin');
  writeln(f);
  writeln(f,'end.');
  CloseFile(f);
end;

end.
