unit Main_Unit;
{Pascal shell - program uatwiajcy stworzenie rodowiska programowania dla
 dowolnego kompilatora.
 Program umozliwia wywoanie dowolnego edytora tekstu, wywouje kompilator,
 wywietla opisy bdw kompilacji i uruchamia skompilowany program. Istnieje
 take mozliwo wywoywania plikw pomocy.
 Kod rdowy programu dostpny jest pod adresem:  http://akropolis.pol.lublin.pl/lmn/
 i moze byc rozpowszechniany na zasadach Open Source.
 Autor (Jerzy Podgrski) prosi o informacje dotyczce wykorzystania tego kodu do
 wasnych celw na adres:
 jpkmb@akropolis.pol.lublin.pl
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, Buttons, ComCtrls, ToolWin, ShellAPI;


type
  TMain_Form = class(TForm)

    MainMenu1: TMainMenu;
      Pliki1: TMenuItem;
        NoweZadanie: TMenuItem;
        OtworzZadanie: TMenuItem;
        S______1: TMenuItem;
        Koniec1: TMenuItem;
    Kompitator: TMenuItem;

      Info1: TMenuItem;
        Pomoc1: TMenuItem;


    StatusBar1: TStatusBar;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;

    BtnNoweZadanie: TBitBtn;
    BtnCzytajZadanie: TBitBtn;
    Oprogramie1: TMenuItem;
    Uruchom_edytor: TMenuItem;
    BtnGoTo_edytor: TBitBtn;
    Kompilacja1: TMenuItem;
    Kompiluj1: TMenuItem;
    Uruchom1: TMenuItem;
    Pomocopisjzyka1: TMenuItem;
    Pomocopis1: TMenuItem;
    Konfiguracja1: TMenuItem;
    Szukajedytora1: TMenuItem;
    Szukajkompilatora1: TMenuItem;
    SzukajOpisuBibliotek: TMenuItem;
    SzukajOpisuJezyka: TMenuItem;
    SzukajOpisuKompilatora: TMenuItem;
    ZapiszKonfiguracje: TMenuItem;
    BtnKompiluj: TBitBtn;
    N2: TMenuItem;
    N3: TMenuItem;
    Bevel1: TBevel;
    SzukajArcobatReadera: TMenuItem;
    OpisBibliotek: TBitBtn;
    OpisJezyka: TBitBtn;
    N4: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    PokazKonfiguracje: TMenuItem;
    RaportKompilacji: TMenuItem;
    Label7: TLabel;
    Label5: TLabel;
    OpisKompilatora: TBitBtn;
    BtnUruchom: TBitBtn;



    procedure Oprogramie1Click(Sender: TObject);
    procedure Koniec1Click(Sender: TObject);
    procedure NoweZadanieClick(Sender: TObject);
    procedure OtworzZadanieClick(Sender: TObject);
    procedure BtnNoweZadanieClick(Sender: TObject);
    procedure BtnCzytajZadanieClick(Sender: TObject);
    procedure Uruchom_edytorClick(Sender: TObject);
    procedure BtnGoTo_edytorClick(Sender: TObject);
    procedure BtnKompilujClick(Sender: TObject);
    procedure Pomoc1Click(Sender: TObject);
    procedure Pomocopisjzyka1Click(Sender: TObject);
    procedure Pomocopis1Click(Sender: TObject);
    procedure Szukajedytora1Click(Sender: TObject);
    procedure Szukajkompilatora1Click(Sender: TObject);
    procedure SzukajOpisuBibliotekClick(Sender: TObject);
    procedure SzukajOpisuJezykaClick(Sender: TObject);
    procedure SzukajOpisuKompilatoraClick(Sender: TObject);
    procedure SzukajArcobatReaderaClick(Sender: TObject);
    procedure ZapiszKonfiguracjeClick(Sender: TObject);
    procedure OpisBibliotekClick(Sender: TObject);
    procedure OpisJezykaClick(Sender: TObject);
    procedure PokazKonfiguracjeClick(Sender: TObject);
    procedure Uruchom1Click(Sender: TObject);
    procedure RaportKompilacjiClick(Sender: TObject);
    procedure OpisKompilatoraClick(Sender: TObject);
    procedure BtnUruchomClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
procedure StatusBarUpdate;

var
  Main_Form: TMain_Form;

implementation
uses GlobalVar, About_Unit, Config_Unit, Raport_Unit;
{$R *.DFM}

procedure TMain_Form.Oprogramie1Click(Sender: TObject);
begin
    About_Form.ShowModal;
end;

procedure TMain_Form.Koniec1Click(Sender: TObject);
begin
  Application.Terminate;
end;


procedure ErrorMessage(Nr:integer;Fname:string);
const ErrorText:array[1..5]of string=
  {1} ('Nie mona odnale pliku: ',
  {2}  'Nie mona otworzy pliku: ',
  {3}  'Komunikat kompilatora: ',
  {4}  'Bd',
  {5}  'Nie mona skompilowa: ');

begin
  if Nr>0 then Application.MessageBox(Pchar(ErrorText[Nr]+Fname),
                                     ' Bd kompilacji!',
                                     MB_OK+
                                     MB_ICONWARNING+
                                     MB_DEFBUTTON1);
end;




function Time_Out(TimeDelay:TDateTime):boolean;
var dT : TDateTime;

begin
  dT:=Time-TimeStart;
  Time_Out:=dT>TimeDelay
end;


procedure Sprawdzenie(var Err : integer);
var f   : TextFile;
    linia : string;
    p,p1,p2: integer;
begin
  Err:=0; TimeStart:=GetTime;
  repeat until FileExists(ProblemDir+'fpcdebug.txt') or Time_Out(1E-6);
  AssignFile(f,ProblemDir+'fpcdebug.txt');
  TimeStart:=GetTime;
  repeat
    {$I-}
    reset(f);
    {$I+}
    Err:=IOresult;
  until (Err=0) or Time_Out(1e-5);
  if Err=0 then
  repeat
    readln(f,linia);
    p:=pos('Fatal',linia);
    if p>0 then
    begin
      p1:=pos('(',linia);
      if p1>0 then
      begin
        Err:=4;
        Delete(linia,1,p1-1);
        p2:=pos(')',linia);
        Insert('Komunikat: ',linia,p2+2);
        p2:=pos(',',linia);
        Insert('kolumna:',linia,p2+1);
        Insert('wiersz:',linia,2);
        p:=pos('Fatal',linia);
        if p>0 then Delete(linia,p,6);
      end else
      begin
        Err:=3;
        Delete(linia,1,p+6);
      end;
    end;
  until eof(f) or (Err>0) else Err:=5;
  {$I-}
    CloseFile(f);
  {$I+}

  if Err=3 then ErrorMessage(Err,linia);
  if Err=4 then ErrorMessage(Err,linia);
  if Err=5 then ErrorMessage(Err,ProblemFileName);
end;


procedure StatusBarUpdate;
begin
  with Main_Form.StatusBar1 do
  begin
    Panels[0].Text := 'Plik: '+ExtractFileName(ProblemFileName);
    Panels[1].Text := 'Kompilator: '+ChangeFileExt(ExtractFileName(Kompilator_Exe),'');
    Panels[2].Text := 'Edytor: '+ChangeFileExt(ExtractFileName(Edytor_Exe),'');
  end;
{
  with Main_Form do
  begin
    BtnRysuj.Hint  :='Rysuj: '+SuperDrawExe;
    BtnDekoduj.Hint:='Dekoduj: '+DecoderExe;
    BtnOblicz.Hint :='Oblicz: '+OpisAnalizy[AnalyTypNr].Proc;
    BtnPokazWyniki.Hint:='Poka wyniki: '+SuperViewExe;
    BtnRaport.Hint:='Poka raport: *'+RaportExt;
  end;
}
end;

function FileExist(Fname:string):boolean;
var  OK : boolean;
begin
  OK:=FileExists(Fname);
  FileExist:=OK;

  if not OK then Application.MessageBox(Pchar('Nie mona odnale pliku: '+Fname),
                                     ' Bd!',
                                     MB_OK+
                                     MB_ICONWARNING+
                                     MB_DEFBUTTON1);


end;


procedure OtworzNoweZadanie;
begin
  with Main_Form do
  begin
    SaveDialog1.Title := 'Utwrz nowy plik';
    {SaveDialog1.Width :=500;}
    SaveDialog1.InitialDir:=ProblemDir;

    SaveDialog1.Filter := 'Pliki programw (*.pas)|*.PAS';
    SaveDialog1.DefaultExt:='*.PAS';
    if SaveDialog1.Execute then { Display Save dialog box}
    ProblemFileName:=ExtractFileName(SaveDialog1.FileName);
    ProblemDir:=ExtractFilePath(SaveDialog1.FileName);
    //ProblemFileName:=ChangeFileExt(ProblemFileName,'');
    if not FileExists(SaveDialog1.FileName)then Write_new_file;
  end;
  StatusBarUpdate;
end;

procedure TMain_Form.NoweZadanieClick(Sender: TObject);
var FileName:string;
begin
  OtworzNoweZadanie;
end;


procedure TMain_Form.BtnNoweZadanieClick(Sender: TObject);
begin
  OtworzNoweZadanie;
end;


function ProcessExecute(CommandLine: string): Integer;
{ Ta metoda zamyka w sobie wywoanie funkcji CreateProcess() tworzcej
  nowy proces i jego wtek gwny, a uywanej przez aplikacj 32-bitow
  do uruchamiania innych programw. Wymaga ona parametrw w postaci
  struktur TStartInfo i TProcessInformation; struktury te nie s
  udokumentowane w Delphi 4, lecz odpowiadaj udokumentowanym
  strukturom Win32 o nazwach STARTUPINFO i PROCESS_INFORMATION.
  Parametr CommandLine zawiera nazw pliku wykonywalnego, a parametr
  cShow okrela rodzaj okna gwnego nowego procesu; jego warto
  przypisywana jest do pola wShowWindow w strukturze TStartupInfo   }


var
  Rslt: LongBool;
  StartUpInfo: TStartUpInfo;
  ProcessInfo: TProcessInformation;
  cShow: Word;
begin
{ Wyzeruj pola struktury StartupInfo }
  FillChar(StartupInfo, SizeOf(TStartupInfo), 0);

{ Zainicjuj struktur StartupInfo: do pola wShowWindow przypisz
  parametr cShow, ustaw flag STARTF_USESSHOWWINDOW w zbiorze dwFlags }

  cShow:=SW_SHOWNORMAL; {help dla --> ShellExecute}
  with StartupInfo do
  begin
    cb      := SizeOf(TStartupInfo); // Rozmiar struktury
    dwFlags := STARTF_USESHOWWINDOW or STARTF_FORCEONFEEDBACK;
    wShowWindow := cShow
  end;

{ Utwrz nowy proces wywoujc CreateProcess(). W wyniku wywoania
  funkcja wypenia struktur ProcessInfo informacj na temat nowego
  procesu i jego wtku gwnego }

  Rslt := CreateProcess(PChar(CommandLine), nil, nil, nil, False,
    NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInfo);

(*
 BOOL CreateProcess(
 LPCTSTR lpApplicationName,   {pointer to name of executable module}
 LPTSTR lpCommandLine,	      {pointer to command line string}
 LPSECURITY_ATTRIBUTES lpProcessAttributes,	{pointer to process security attributes}
 LPSECURITY_ATTRIBUTES lpThreadAttributes,	{pointer to thread security attributes}
 BOOL bInheritHandles,	      {handle inheritance flag}
 DWORD dwCreationFlags,	      {creation flags}
 LPVOID lpEnvironment,	      {pointer to new environment block}
 LPCTSTR lpCurrentDirectory,	{pointer to current directory name}
 LPSTARTUPINFO lpStartupInfo,	{pointer to STARTUPINFO}
 LPPROCESS_INFORMATION lpProcessInformation  {pointer to PROCESS_INFORMATION}
);
*)

{ Warto TRUE zmiennej Rslt oznacza pomylne utworzenie procesu,
  w przeciwnym wypadku kod bdu osigalny jest dziki GetLastError}

  if Rslt then
    with ProcessInfo do
    begin
    { poczekaj na bezczynno procesu. }
      WaitForInputIdle(hProcess, INFINITE);

      CloseHandle(hThread); // Zamknij wtek gwny procesu
      CloseHandle(hProcess);// Zamknij proces
      Result := 0;          // Sygnalizacja, e wszystko OK
    end
  else
   Result := GetLastError; // Warto niezerowa oznacza bd
end;


procedure RunModule(ExeName,FileName:string);
var RetVal: THandle;
begin
  if FileExist(ExeName) {and FileExist(ProblemDir+FileName)} then
  begin
    RetVal := ShellExecute(Application.MainForm.Handle,'open',
            Pchar(ExeName),
            Pchar(FileName), Pchar(ProblemDir),
            SW_SHOWNORMAL);
    if RetVal < 32 then RaiseLastWin32Error;
  end;
end;


procedure TMain_Form.Uruchom_edytorClick(Sender: TObject);
begin
//Uruchom edytor
  RunModule(Edytor_Exe,ProblemFileName);
end;

procedure TMain_Form.BtnGoTo_edytorClick(Sender: TObject);
begin
//Uruchom edytor
  RunModule(Edytor_Exe,ProblemFileName);
end;


function CzytajZadanie:boolean;
var Fname:string;
    OK:boolean;
begin
  OK:=false;
  with Main_Form.OpenDialog1 do
  begin
    InitialDir:=ExtractFilePath(ProblemDir);
    Title := 'Czytaj plik programu';
    Filter := 'Pliki pascala (*.pas)|*.PAS';
    DefaultExt:='*.pas';
    if Execute then
    begin
      ProblemFileName:=ExtractFileName(FileName);
      ProblemDir:=ExtractFilePath(FileName);
      StatusBarUpdate;
      OK:=true;
    end;
  end;
  if OK and (Application.MessageBox('Uruchomi edytor tekstu?',
            ' Czytanie pliku z dysku',
              MB_YESNO + MB_ICONQUESTION+ MB_DEFBUTTON1)=IDYES)	then
              RunModule(Edytor_Exe,ProblemFileName);

end;

procedure TMain_Form.OtworzZadanieClick(Sender: TObject);
begin
  CzytajZadanie;
end;

procedure TMain_Form.BtnCzytajZadanieClick(Sender: TObject);
begin
  CzytajZadanie;
end;




procedure RunProgram;
begin
  if ProblemDir[Length(ProblemDir)]<>'\' then ProblemDir:=ProblemDir+'\';
  RunModule(ProblemDir+ChangeFileExt(ProblemFileName,'.exe'),'');
end;


procedure TMain_Form.BtnKompilujClick(Sender: TObject);
var Err:integer;
begin
 //Kompilacja
  DeleteFile(ProblemDir+'fpcdebug.txt');
  RunModule(Kompilator_Exe,'"'+ProblemFileName+' -vv"');
  Sprawdzenie(Err);
  if (Err=0) and (Application.MessageBox('Kompilacja zakoczona sukcesem! Uruchomi program?',
                 ' Kompilacja i uruchomienie programu',
                 MB_YESNO	+ MB_ICONQUESTION+
                 MB_DEFBUTTON1)=IDYES)	then RunProgram

//  ProcessExecute(Kompilator_Exe+' '+ProblemFileName+' >raport.txt');
end;

procedure TMain_Form.Uruchom1Click(Sender: TObject);
begin
  RunProgram;
end;

procedure TMain_Form.BtnUruchomClick(Sender: TObject);
begin
  RunProgram;
end;

procedure TMain_Form.Pomoc1Click(Sender: TObject);
begin
//Pomoc - Run-Time Library
  RunModule(PDF_Reader,RTL_file);
end;

procedure TMain_Form.Pomocopisjzyka1Click(Sender: TObject);
begin
//Pomoc - Reference guide
  RunModule(PDF_Reader,Reference_file);
end;

procedure TMain_Form.Pomocopis1Click(Sender: TObject);
begin
//Free Pascal Users manual
  RunModule(PDF_Reader,User_manual_file);
end;

procedure TMain_Form.Szukajedytora1Click(Sender: TObject);
begin
//Szukaj edytora
  with Main_Form.OpenDialog1 do
  begin
    Title := 'Poszukiwanie edytora tekstu';
    Filter := 'Edytory  (*.EXE)|*.EXE';
    DefaultExt:='.EXE';
		FileName:=ExtractFileName(Edytor_Exe);
		InitialDir:=ExtractFilePath(Edytor_Exe);
    if Execute then Edytor_Exe:=FileName;
  end;
  StatusBarUpdate;
end;

procedure TMain_Form.Szukajkompilatora1Click(Sender: TObject);
begin
//Szukaj kompilatora
  with Main_Form.OpenDialog1 do
  begin
    Title := 'Poszukiwanie kompilatora Pascala';
    Filter := 'Kompilatory  (*.EXE)|*.EXE';
    DefaultExt:='.EXE';
		FileName:=ExtractFileName(Kompilator_Exe);
		InitialDir:=ExtractFilePath(Kompilator_Exe);
    if Execute then Kompilator_Exe:=FileName;
  end;
  StatusBarUpdate;
end;

procedure TMain_Form.SzukajOpisuBibliotekClick(Sender: TObject);
begin
//Szukaj opisu bibliotek
  with Main_Form.OpenDialog1 do
  begin
    Title := 'Poszukiwanie opisu bibliotek Pascala';
    Filter := 'Dokumenty (*.pdf)|*.PDF|Win help (*.hlp)|*.HLP|Inne pliki (*.*)|*.*';
    DefaultExt:='.pdf';
		FileName:=ExtractFileName(RTL_file);
		InitialDir:=ExtractFilePath(RTL_file);
    if Execute then RTL_file:=FileName;
  end;

end;

procedure TMain_Form.SzukajOpisuJezykaClick(Sender: TObject);
begin
//Szukaj opisu jzyka
  with Main_Form.OpenDialog1 do
  begin
    Title := 'Poszukiwanie opisu jzyka Pascal';
    Filter := 'Dokumenty (*.pdf)|*.PDF|Win help (*.hlp)|*.HLP|Inne pliki (*.*)|*.*';
    DefaultExt:='.pdf';
		FileName:=ExtractFileName(Reference_file);
		InitialDir:=ExtractFilePath(Reference_file);
    if Execute then Reference_file:=FileName;
  end;

end;

procedure TMain_Form.SzukajOpisuKompilatoraClick(Sender: TObject);
begin
//Szukaj opisu kompilatora
  with Main_Form.OpenDialog1 do
  begin
    Title := 'Poszukiwanie opisu kompilatora';
    Filter := 'Dokumenty (*.pdf)|*.PDF|Win help (*.hlp)|*.HLP|Inne pliki (*.*)|*.*';
    DefaultExt:='.pdf';
		FileName:=ExtractFileName(User_manual_file);
		InitialDir:=ExtractFilePath(User_manual_file);
    if Execute then User_manual_file:=FileName;
  end;
end;

procedure TMain_Form.SzukajArcobatReaderaClick(Sender: TObject);
begin
//Szukaj Acrobat Readera
  with Main_Form.OpenDialog1 do
  begin
    Title := 'Program wyswietlajcy pliki pomocy';
    Filter := 'Pdf reader (Acrobat Reader)|AcroRd32.exe|Hlp reader (Windows help)|HH.exe|Inne programy|*.exe';
    DefaultExt:='.exe';
		FileName:=ExtractFileName('*.exe');
		InitialDir:=ExtractFilePath(PDF_Reader);
    if Execute then PDF_Reader:=FileName;
  end;

end;

procedure TMain_Form.ZapiszKonfiguracjeClick(Sender: TObject);
begin
//Zapisz konfiguracj
  ZapiszNazwy;
end;

procedure TMain_Form.OpisBibliotekClick(Sender: TObject);
begin
  //Pomoc - Run-Time Library
  RunModule(PDF_Reader,RTL_file);
end;

procedure TMain_Form.OpisJezykaClick(Sender: TObject);
begin
//Pomoc - Reference guide
  RunModule(PDF_Reader,Reference_file);
end;

procedure TMain_Form.PokazKonfiguracjeClick(Sender: TObject);
begin
//Poka konfiguracj
  InitListBox;
  Config_Form.ShowModal;
end;

procedure TMain_Form.RaportKompilacjiClick(Sender: TObject);
begin
  Raport_Form.Show;
  CzytajRaport('fpcdebug.txt');
end;

procedure TMain_Form.OpisKompilatoraClick(Sender: TObject);
begin
//Free Pascal Users manual
  RunModule(PDF_Reader,User_manual_file);
end;

end.



