unit Raport_Unit;
{Pascal shell - program uatwiajcy stworzenie rodowiska programowania dla
 dowolnego kompilatora.
 Program umozliwia wywoanie dowolnego edytora tekstu, wywouje kompilator,
 wywietla opisy bdw kompilacji i uruchamia skompilowany program. Istnieje
 take mozliwo wywoywania plikw pomocy.
 Kod rdowy programu dostpny jest pod adresem:  http://akropolis.pol.lublin.pl/lmn/
 i moze byc rozpowszechniany na zasadach Open Source.
 Autor (Jerzy Podgrski) prosi o informacje dotyczce wykorzystania tego kodu do
 wasnych celw na adres:
 jpkmb@akropolis.pol.lublin.pl
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TRaport_Form = class(TForm)
    MainMenu1: TMainMenu;
    ZamknijRaport: TMenuItem;
    Refresh: TMenuItem;
    Memo1: TMemo;
    Czcionka1: TMenuItem;
    FontDialog1: TFontDialog;
    CzytajNowy: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure ZamknijRaportClick(Sender: TObject);
    procedure RefreshClick(Sender: TObject);
    procedure Czcionka1Click(Sender: TObject);
    procedure CzytajNowyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function CzytajRaport(Fname:string):boolean;

var
  Raport_Form: TRaport_Form;

implementation

{$R *.DFM}

uses GlobalVar;

var ActualRaportName : string;

function CzytajRaport(Fname:string):boolean;
var Err:boolean;
begin
  ActualRaportName:=Fname;
  Err:=false;
  if FileExists(Fname) then
  begin
    Raport_Form.Caption:='Raport: '+Fname;
    Raport_Form.Memo1.Lines.LoadFromFile(ProblemDir+Fname);
  end else Err:=true;

  if Err then Application.MessageBox(Pchar('Nie mona odnale pliku raportu: '+Fname),
                                     ' Bd!',
                                     MB_OK+
                                     MB_ICONWARNING+
                                     MB_DEFBUTTON1);

  CzytajRaport:=not Err;
end;


procedure TRaport_Form.ZamknijRaportClick(Sender: TObject);
begin
  Close
end;

procedure TRaport_Form.RefreshClick(Sender: TObject);
begin
   CzytajRaport(ActualRaportName);
end;

procedure TRaport_Form.Czcionka1Click(Sender: TObject);
begin
  FontDialog1.Options := [fdFixedPitchOnly];
  FontDialog1.MaxFontSize := 14;
  FontDialog1.MinFontSize := 6;
  if FontDialog1.Execute then
    Memo1.Font := FontDialog1.Font;
end;

procedure TRaport_Form.CzytajNowyClick(Sender: TObject);
var Fname:string;
begin
  //Czytaj nowy raport
  Fname:='';
  with Raport_Form.OpenDialog1 do
  begin
    InitialDir:=ExtractFilePath(ProblemDir);
    Title := 'Czytaj plik raportu';
    Filter := 'Pliki raportw (*.txt)|*.TXT|Pliki raportw (*.log)|*.LOG|Pliki raportw (*.rpt)|*.RPT|Inne pliki (*.*)|*.*';
    DefaultExt:='*.txt';

    if Execute then Fname:=ExtractFileName(FileName);
  end;
  if Fname<>'' then CzytajRaport(Fname);

end;

end.

